﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Reflection;
using System.IO;
using System.Timers;
using System.Threading;
using System.Globalization; 
using System.Text.RegularExpressions;
using System.Diagnostics;



namespace Sample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {  
        Model mod = new Model();

        System.Timers.Timer myTimer = new System.Timers.Timer( 100 ); // 100 ms            
         
        // each time that the dispatcherTimer event is on the timer will increment by 1
        int time = 0;

        Point Pt;
        int XMval;
        double YMval;

        Point PrevPt;
        int PrevXMval;
        double PrevYMval;
         
        int newXval;
        int newPrevXval;
          
   
        bool errMessage = false;



        public MainWindow()
        {
            InitializeComponent();
             
            yAxis.Minimum = Globals.minYAxis;
            yAxis.Maximum = Globals.maxYAxis;
             
            main.Width = SystemParameters.PrimaryScreenWidth;
            main.Height = SystemParameters.PrimaryScreenHeight;

            chart1.Width = SystemParameters.PrimaryScreenWidth - 100;
            chart1.Height = SystemParameters.PrimaryScreenHeight - 300;
             
            mod.CreateDatas( 0 );
          
            SizeInput.Text = Globals.CurrentWaveLength.ToString();
            WaveSizeInput.Text = Globals.CurrentWaveLength.ToString();

            AdjustWaveLength();
             
            chart1.Series[0].ItemsSource = mod.measurments;
          
            chart1.MouseLeftButtonUp += new MouseButtonEventHandler( chart1_MouseLeftButtonUp );
            chart1.MouseMove += new MouseEventHandler( chart1_MouseMove );

            myTimer.Elapsed += new ElapsedEventHandler( Timer_Tick );
             
            time = Globals.RESET;
            myTimer.Start();
             
        }


         


        private void chart1_MouseLeftButtonUp( object sender, MouseButtonEventArgs e )
        {
            PrevPt.X = 0;
            PrevPt.Y = 0;
        }






        public void chart1_MouseMove( object sender, MouseEventArgs e )
        {
            if( e.LeftButton == MouseButtonState.Pressed )
            {
                if( e.Source.Equals( sender ) )
                {
                    chart1.Series[0].ItemsSource = null;
                      
                    Pt = e.GetPosition( chart1.Series[0] );
                    
                    if( Pt.X >= 0 && Pt.X <= chart1.Width && Pt.Y >= 0 && Pt.Y <= chart1.Height )
                    {
                        if( ( PrevPt.X == 0 ) && ( PrevPt.Y == 0 ) )
                        {
                            PrevPt = Pt;
                            PrevXMval = Convert.ToInt32( chart1.PointToValue( chart1.PrimaryAxis, Pt ) );
                            PrevYMval = ( chart1.PointToValue( chart1.SecondaryAxis, Pt ) );

                            newPrevXval = Convert.ToInt32( Convert.ToDouble( PrevXMval ) / Convert.ToDouble( Globals.CurrentWaveLength ) * Convert.ToDouble( /*SizeInput.Text*/ mod.measurments.Count ) );
                       
                        }

                        try
                        {
                            XMval = Convert.ToInt32( chart1.PointToValue( chart1.PrimaryAxis, Pt ) );
                            YMval = ( chart1.PointToValue( chart1.SecondaryAxis, Pt ) );

                            if( Globals.SkipSize == 1 )
                            {
                                newXval = XMval;
                            }
                            else
                            {
                                newXval = Convert.ToInt32( Convert.ToDouble( XMval ) / Convert.ToDouble( Globals.CurrentWaveLength ) * Convert.ToDouble( /*SizeInput.Text*/ mod.measurments.Count ) );
                            }

                            byte[] tmp;
                            double val = 0;
                            double Result = 0;


                            if( YMval < -1 )
                            {
                                YMval = -1;
                            }

                            if( ( newXval < mod.measurments.Count ) )
                            {
                                double rr = mod.measurments[newXval].X;

                                mod.measurments[newXval].Y = YMval;

                                if( PrevPt != Pt )
                                {
                                    if( newPrevXval < newXval )
                                    {
                                        for( Int32 i = newPrevXval; i < newXval; i++ )
                                        {
                                            val = linear( i, newPrevXval, newXval, PrevYMval, YMval );

                                            mod.measurments[i].Y = val;

                                            Result = ( ( ( val + 1 ) / 2 ) * Globals.MAX_DAC );

                                            tmp = BitConverter.GetBytes( Convert.ToUInt16( Result + 0.5 ) );

                                            Globals.ByteArray[2 * i] = tmp[0];
                                            Globals.ByteArray[2 * i + 1] = tmp[1];
                                        }
                                    }

                                    else if( newPrevXval > newXval )
                                    {
                                        for( Int32 i = newXval; i < newPrevXval; i++ )
                                        {
                                            val = linear( i, newPrevXval, newXval, PrevYMval, YMval );

                                            mod.measurments[i].Y = val;

                                            Result = ( ( ( val + 1 ) / 2 ) * Globals.MAX_DAC );

                                            tmp = BitConverter.GetBytes( Convert.ToUInt16( Result + 0.5 ) );

                                            Globals.ByteArray[2 * i] = tmp[0];
                                            Globals.ByteArray[2 * i + 1] = tmp[1];
                                        }
                                    }

                                }

                                PrevPt = Pt;
                                newPrevXval = newXval;
                                PrevYMval = YMval;
                            }

                        }
                        catch
                        {
                        }
                    }

                    chart1.Series[0].ItemsSource = mod.measurments; 

                }

            }


        }
         




        static public double linear( double x, double x0, double x1, double y0, double y1 )
        {
            if( ( x1 - x0 ) == 0 )
            {
                return ( y0 + y1 ) / 2;
            }
            return y0 + ( x - x0 ) * ( y1 - y0 ) / ( x1 - x0 );
        }


         

         


        private void NumberValidationTextBox( object sender, TextCompositionEventArgs e )
        {
            Regex regex = new Regex( "[^0-9]+" );
            e.Handled = regex.IsMatch( e.Text );
        }




           


        private void WaveSizeInput_KeyDown( object sender, KeyEventArgs e )
        {
            if( e.Key == Key.Enter )
            {
                PrevPt.X = 0;
                PrevPt.Y = 0;


                if( ( Convert.ToInt32( WaveSizeInput.Text ) >= Globals.MIN_SIZE_OF_POINTS ) && ( Convert.ToInt32( WaveSizeInput.Text ) <= Globals.MAX_SIZE_OF_POINTS ) )
                {
                    AdjustWaveLength();
                }
                else
                {
                    ErrorMessage.Content = "Fix Wavelength!";
                    errMessage = true;

                    time = Globals.RESET;
                    myTimer.Start();
                }

 
            }
        }



        

        public void AdjustWaveLength()
        {  
            int i = 0;
            int waveLength = 0;
             
            waveLength = Convert.ToInt32( WaveSizeInput.Text );

            if( waveLength % Globals.POINTS_DIVIDED_BY == 0 )
            {
                Globals.PreviousWaveLength = Globals.CurrentWaveLength;
                Globals.CurrentWaveLength = waveLength;
            }
            else
            {
                // SizeInput is not divisible without remainder - find nearest SizeInput that divided without remainder
                Globals.PreviousWaveLength = Globals.CurrentWaveLength;
                Globals.CurrentWaveLength = waveLength - ( waveLength % Globals.POINTS_DIVIDED_BY );
                ErrorMessage.Content = "Wavelength adjusted!";
                errMessage = true;

                time = Globals.RESET;
                myTimer.Start();
            }

            // dov
            var liste = new List<byte>( Globals.ByteArray );

          

            // resize array
            Array.Resize( ref Globals.ByteArray, 2 * Globals.CurrentWaveLength );

            if( Globals.CurrentWaveLength > Globals.MAX_SIZE_OF_CHART )
            { 
                Globals.SkipSize = Globals.CurrentWaveLength / ( double )Globals.MAX_SIZE_OF_CHART;
                
            }
            else
            {
                Globals.SkipSize = 1;
               
            }

            WaveSizeInput.Text = Globals.CurrentWaveLength.ToString();

            if( Globals.PreviousWaveLength != Globals.CurrentWaveLength )
            {
                if( Globals.PreviousWaveLength < Globals.CurrentWaveLength )
                {
                    chart1.Series[0].ItemsSource = null;

                    mod.CreateDatas( Convert.ToInt32( Globals.PreviousWaveLength ) );

                    chart1.Series[0].ItemsSource = mod.measurments;
                }
                else if( Globals.PreviousWaveLength > Globals.CurrentWaveLength )
                { 
                    for( i = 2 * Globals.PreviousWaveLength - 1; i >= 2 * Globals.CurrentWaveLength; i-- )
                    {
                        liste.RemoveAt( i );
                    }
                     
                    Globals.ByteArray = liste.ToArray();

                }

            }


            // set xAxis data
            xAxis.Minimum = 0;
            xAxis.Maximum = Globals.CurrentWaveLength - 1;


            WriteToSfChart();

            SizeInput.Text = mod.measurments.Count.ToString();
             

        }

       







        public void WriteToSfChart()
        {

            short[] samples = new short[Globals.ByteArray.Length / 2];
            Buffer.BlockCopy( Globals.ByteArray, 0, samples, 0, Globals.ByteArray.Length );

            int i = 0;


            double[] dew = new double[samples.Length];

            mod.measurments.Clear();

            chart1.Series[0].ItemsSource = null;


            for( i = 0; i < samples.Length; i++ )
            {
                if( i % Convert.ToInt16( Globals.SkipSize ) == 0 )
                {
                    mod.measurments.Add( new Model( i, ( ( ( samples[i] + 0.5 ) / Globals.MAX_DAC * 2 ) - 1 ) ) );

                }

            }

            chart1.Series[0].ItemsSource = mod.measurments; 
        }



 

      




        private void Timer_Tick( object sender, EventArgs e )
        {
            time++;

            if( time == 20 && errMessage == true )
            {
                errMessage = false;

                Dispatcher.Invoke( new Action( () => { ErrorMessage.Content = ""; } ) );
                myTimer.Stop();
            }
             
        }






        private void zoomCheckBox_Checked( object sender, RoutedEventArgs e )
        {
            chart1.MouseLeftButtonUp -= new MouseButtonEventHandler( chart1_MouseLeftButtonUp );
            chart1.MouseMove -= new MouseEventHandler( chart1_MouseMove );

            var behaviour = new ChartZoomPanBehavior()
            {
                EnablePinchZooming = true,
                EnableZoomingToolBar = true,
                EnableSelectionZooming = true,
                EnableMouseWheelZooming = true,
                EnablePanning = true,
                ResetOnDoubleTap = true,
                HorizontalPosition = HorizontalAlignment.Right,
                ToolBarItemHeight = 30,
                ToolBarItemWidth = 30,
                ToolBarItemMargin = new Thickness(5),
                ZoomMode = ZoomMode.XY
            };
            chart1.Behaviors.Add(behaviour);
        }

        private void zoomCheckBox_Unchecked( object sender, RoutedEventArgs e )
        {
            chart1.MouseLeftButtonUp += new MouseButtonEventHandler( chart1_MouseLeftButtonUp );
            chart1.MouseMove += new MouseEventHandler( chart1_MouseMove );
           chart1.Behaviors.Clear();
        }


         


         
      

  
 
     







    }



    public class Model : INotifyPropertyChanged
    {
        public ObservableCollection<Model> measurments { get; set; }

        private double x;

        public double X
        {
            get { return x; }
            set
            {
                if( x != value )
                {
                    x = value;
                    OnPropertyChanged( "X" );
                }
            }
        }

        private double y;
        public double Y
        {
            get { return y; }
            set
            {
                if( y != value )
                {
                    y = value;
                    OnPropertyChanged( "Y" );
                }
            }
        }



        public Model( double xValue, double yValue )
        {
            X = xValue;
            Y = yValue;
        }




        public Model()
        {

        }




        public void CreateDatas( int currentValue )
        { 
            int i = currentValue; 
             
            double Value = ( Globals.maxYAxis + Globals.minYAxis ) / 2;
          
            byte[] tmp1 = BitConverter.GetBytes( ( UInt16 )( ( Globals.MAX_DAC / 2 ) + 0.5 ) );

            if( measurments == null )
            {
                measurments = new ObservableCollection<Model>();
            }
 
            for( ; i < Globals.CurrentWaveLength; i++ )
            {
                Globals.ByteArray[2 * i] = tmp1[0];
                Globals.ByteArray[2 * i + 1] = tmp1[1]; 
            }
             
 
        }







         


        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged( string propertyName = null )
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if( handler != null )
                handler( this, new PropertyChangedEventArgs( propertyName ) );
        }



    }

}
